/**
 * Created by jimiz on 2017/4/1.
 */
let mongoose = require("mongoose");
let db = require("../db/project_db");
let subSchema = require("./bills_sub_schemas");
let deleteSchema = require('../../../public/models/delete_schema');
let Schema = mongoose.Schema;
let async = require("async");
let counter = require("../../../public/counter/counter.js");
let consts = require('./project_consts');
let projectConsts = consts.projectConst;
let commonConsts = consts.commonConst;

let billsSchema = new Schema({
    ID: Number,
    ParentID: Number,
    NextSiblingID: Number,
    projectID: Number,
    serialNo: Number,
    chapterID: Number,
    code: String,
    fullCode: String,
    name: String,
    unit: String,
    quantity: String, // Decimal
    programID: Number,
    comments: String,
    // 调价
    xs_Labour: String, // Decimal
    xs_Material: String, // Decimal
    xs_Machine: String, // Decimal
    xs_FeeRate: String, // Decimal
    xs_LabourPrice: String, // Decimal
    xs_MaterialPrice: String, // Decimal
    xs_MachinePrice: String, // Decimal
    isTender_Labour: Boolean,
    isTender_Material: Boolean,
    isTender_Machine: Boolean,
    tenderTargetPrice: String, // Decimal
    tenderTargetUnitPrice: String, // Decimal
    tenderTargetUnitPrice: String, // Decimal
    // 费用字段
    fees: [subSchema.feesSchema],
    // 标记字段
    flags: [subSchema.flagsSchema],
    deleteInfo: deleteSchema
});

let bills = db.model("bills", billsSchema);
let baseModel = require('./base_model');

class billsModel extends baseModel {
    constructor () {
        super(bills);
    };

    getData (projectID, callback) {
        this.model.find({'$or': [{projectID: projectID, deleteInfo: null}, {projectID: projectID, 'deleteInfo.deleted': {$in: [null, false]}}]}, '-_id', function(err, datas){
            if (!err) {
                callback(0, projectConsts.BILLS, datas);
            } else {
                callback(1, projectConsts.BILLS, null);
            };
        });
    };

    save (user_id, datas, callback) {
        let functions = [];
        let data;

        function saveOne(doc) {
            return function (cb) {
                switch (doc.updateType) {
                    case commonConsts.UT_UPDATE:
                        bills.update({projectID: doc.updateData.projectID, ID: doc.updateData.ID}, doc.updateData, cb);
                        break;
                    case commonConsts.UT_CREATE:
                        bills.create(doc.updateData, cb);
                        break;
                    case commonConsts.UT_DELETE:
                        doc.updateData.deleteInfo = {deleted: true, deleteDateTime: new Date(), deleteBy: user_id};
                        bills.update({projectID: doc.updateData.projectID, ID: doc.updateData.ID}, doc.updateData, cb);
                        break;
                }
            }
        }
        for (let i = 0; i < datas.length; i++){
            data = datas[i];
            functions.push(saveOne(data));
        }

        async.parallel(functions, callback);
    };

    getItemTemplate (callback) {
        let data = new bills;
        /* to do: 需要根据标准配置库填充fees和flags字段，是否需要更多的参数？ */
        callback(0, '', data);
    };

    allocIDs (IDStep, callback) {
        counter.counterDAO.getIDAfterCount(counter.moduleName.bills, IDStep, function(err, highID){
            let lowID = highID - IDStep + 1;
            callback(0, '', {lowID: lowID, highID: highID});
        });
    };
};

module.exports = new billsModel();